Subject: some questions about the implementation of oprofile of mpc8560 in linux kernel source code

From: "0x0000" <[email-masked]>
Date: Mon, 11 May 2009 20:36:58 +0800

Dear All,

I am a user of oprofile. When I use oprofile, I find some problems. Could you please help me? 

I have some questions about the open source code of the implementation of oprofile in linux 
kernel 2.6.26, which is presented op_model_fsl_emb.c, and the path in linux kernel source 
tree is arch/powerpc/oprofile/op_model_fsl_emb.c. 

To present this question more clearly, It needs the following steps: 

1> I give some cpu event and its counter values, which finally will call the function fsl_emb_reg_setup 

2> I execute setup, which finally will call the function fsl_emb_cpu_setup 

3> I execute start, which finally will call the function fsl_emb_start 

4> After calling start, the MPC8560 CPU will continuing increasing the PMCn value until its value reach 
0x80000000. Basing on what metioned in E500CORERM.pdf, this value should cause a exception, and 
should goto the interrupt routine:fsl_emb_handle_interrupt. 
But in fact, It never goto this interrupt routine! It always cause a reboot without any information! 

But while we using MPC7450 CPU, this situation never happened, it works well. 

Basing on the information metioned above, my questions are: 
1> Is there any bug in op_model_fsl_emb.c and its related source code? 
2> If possible, could you please tell me what the reason it is? And How to use op_model_fsl_emb.c correctly? 

Any feedback is appreciated! 

Thanks & regards 
Jike

2009-05-11 

0x0000